Bug 781677 (CVE-2011-4461)

Summary: CVE-2011-4461 jetty: hash table collisions CPU usage DoS (oCERT-2011-003)
Product: [Other] Security Response Reporter: Kurt Seifried <kseifried>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: djorm, java-sig-commits, jjohnstn, jkurik, krzysztof.daniel, mizdebsk, msimacek, msrb, overholt, patrickm
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=moderate,public=20111228,reported=20111101,source=distros,cvss2=5.0/AV:N/AC:L/Au:N/C:N/I:N/A:P,rhel-6/jetty-eclipse=wontfix,fedora-all/jetty=affected
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-05-21 09:56:31 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 781678, 781679, 781680    
Bug Blocks: 770929, 782244, 875553    
Attachments:
Description Flags
patch to correct the flaw in jetty-eclipse none

Description Kurt Seifried 2012-01-14 02:00:14 EST
Julian Wälde and Alexander Klink reported a flaw in the hash function used in
the implementation of Java classes as HashMap and Hashtable, see bug #750533.

A specially-crafted set of keys could trigger hash function collisions, which
degrade dictionary performance by changing hash table operations complexity
from an expected/average O(1) to the worst case O(n).  Reporters were able to
find colliding strings efficiently using meet in the middle attack.

A fix for this issue in jetty is available at:

http://dev.eclipse.org/mhonarc/lists/jetty-users/msg01818.html
https://github.com/eclipse/jetty.project/commit/085c79d7d6cfbccc02821ffdb64968593df3e0bf

Please note that for rhel-6 this flaw affects jetty-eclipse which is a "subset of fully[sic] jetty needed to run Eclipse." and as such is not likely to be used in production sites.
Comment 1 Kurt Seifried 2012-01-14 02:02:36 EST
Created jetty tracking bugs for this issue

Affects: fedora-all [bug 781678]
Comment 3 Kurt Seifried 2012-01-18 23:30:37 EST
Confirmed the help system (which runs via jetty) listens to 0.0.0.0:random_port
Comment 4 Tomas Hoger 2012-01-19 04:25:14 EST
(In reply to comment #3)
> Confirmed the help system (which runs via jetty) listens to 0.0.0.0:random_port

This info seems to miss an important bit of a context information and should say: the Eclipse help system
Comment 5 Vincent Danen 2012-01-19 11:16:26 EST
Created attachment 556318 [details]
patch to correct the flaw in jetty-eclipse

This patch will fix the flaw in jetty-eclipse 6.1.24.
Comment 6 Fedora Update System 2012-03-23 20:28:45 EDT
jetty-6.1.26-8.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 7 Murray McAllister 2012-12-20 04:16:56 EST
Acknowledgements:

Red Hat would like to thank oCERT for reporting this issue. oCERT acknowledges Julian Wälde and Alexander Klink as the original reporters.
Comment 8 errata-xmlrpc 2012-12-20 22:10:47 EST
This issue has been addressed in following products:

  Fuse ESB Enterprise 7.1.0

Via RHSA-2012:1604 https://rhn.redhat.com/errata/RHSA-2012-1604.html
Comment 9 errata-xmlrpc 2012-12-20 22:21:07 EST
This issue has been addressed in following products:

  Fuse Management Console 7.1.0

Via RHSA-2012:1606 https://rhn.redhat.com/errata/RHSA-2012-1606.html
Comment 10 errata-xmlrpc 2012-12-20 22:21:40 EST
This issue has been addressed in following products:

  Fuse MQ Enterprise 7.1.0

Via RHSA-2012:1605 https://rhn.redhat.com/errata/RHSA-2012-1605.html
Comment 11 Tomas Hoger 2014-05-21 09:56:31 EDT
The jetty-eclipse in Red Hat Enterprise Linux 6 are included for use by the Eclipse help system.  Due to this limited exposure and impact of this flaw, there is no plan to address this in Red Hat Enterprise Linux 6.

Statement:

The Red Hat Security Response Team has rated this issue as having Low security impact for the jetty-eclipse package in Red Hat Enterprise Linux 6. This issue is not currently planned to be addressed in future updates. For additional information, refer to the Issue Severity Classification: https://access.redhat.com/security/updates/classification/.